import { LitElement, PropertyValues } from 'lit';
import './range-datepicker-calendar.js';
export declare class RangeDatepicker extends LitElement {
    static styles: import("lit").CSSResult;
    /**
     * Array of disabled days. Format is Unix timestamp.
     */
    disabledDays: Array<string>;
    /**
     * Display a select year control.
     */
    enableYearChange: boolean;
    /**
     * Force display of only one month.
     */
    forceNarrow: boolean;
    /**
     * Set locale of the calendar.
     */
    locale: any | null;
    /**
     * Max date. Format is Unix timestamp
     */
    max: string | null;
    /**
     * Minimal date. Format is Unix timestamp
     */
    min: string | null;
    /**
     * Set month.
     * Default is current month.
     */
    month: number;
    /**
     * If true only one date can be selected.
     */
    noRange: boolean;
    /**
     * Set year.
     * Default is current year.
     */
    year: number;
    protected dateFrom: string | null;
    protected dateTo: string | null;
    protected hoveredDate: string | null;
    protected monthPlus: number | null;
    protected yearPlus: number | null;
    protected narrow: boolean;
    constructor();
    render(): import("lit-html").TemplateResult<1>;
    renderNormal(): import("lit-html").TemplateResult<1>;
    renderNarrow(): import("lit-html").TemplateResult<1>;
    firstUpdated(): void;
    updated(properties: PropertyValues): void;
    isNarrow(forceNarrow: boolean, narrow: boolean): boolean;
    queryMatchesChanged(mql: MediaQueryList | MediaQueryListEvent): void;
    handlePrevMonth(): void;
    handleNextMonth(): void;
    hoveredDateChanged(e: CustomEvent): void;
    monthChanged(month: number, year: number): void;
    noRangeChanged(isNoRange: boolean, wasNoRange: boolean): void;
    localeChanged(): void;
    dateToChanged(e: CustomEvent): void;
    dateFromChanged(e: CustomEvent): void;
}
