import { TemplateResult } from 'lit';
import '../src/wc-range-datepicker.js';
declare const _default: {
    title: string;
    component: string;
};
export default _default;
interface Story<T> {
    (args: T): TemplateResult;
    args?: Partial<T>;
    argTypes?: Record<string, unknown>;
}
interface ArgTypes {
    month?: string;
    year?: string;
    min?: string;
    max?: string;
    disabledDays: Array<string>;
    enableYearChange: boolean;
    noRange: boolean;
    forceNarrow: boolean;
    locale: any;
}
export declare const Regular: Story<ArgTypes>;
export declare const CustomMonth: Story<ArgTypes>;
export declare const MinAndMax: Story<ArgTypes>;
export declare const disabledDays: Story<ArgTypes>;
export declare const enableYearChange: Story<ArgTypes>;
export declare const noRange: Story<ArgTypes>;
export declare const forceNarrow: Story<ArgTypes>;
export declare const locale: Story<ArgTypes>;
