/**
 * @typedef {object} StoryOptions
 * @property {HTMLElement | null} StoryOptions.shadowRoot
 */
/** @typedef {(options?: StoryOptions) => ReturnType<LitElement['render']>} LitHtmlStoryFn */
/**
 * Renders a story
 *
 * @element mdjs-story
 * @prop {StoryFn} [story=(() => TemplateResult)] Function that returns the story
 */
export class MdJsStory extends LitElement {
    static get properties(): {
        story: {
            attribute: boolean;
        };
    };
    /** @type {LitHtmlStoryFn} */
    story: LitHtmlStoryFn;
}
export type StoryOptions = {
    shadowRoot: HTMLElement | null;
};
export type LitHtmlStoryFn = (options?: StoryOptions | undefined) => ReturnType<LitElement['render']>;
import { LitElement } from "lit-element/lit-element";
//# sourceMappingURL=MdJsStory.d.ts.map