export declare const styles = "\n  @charset \"utf-8\";\n\n  body {\n    margin:0;\n  }\n\n  #mocha {\n    font: 20px/1.5 \"Helvetica Neue\", Helvetica, Arial, sans-serif;\n    margin: 60px 50px;\n  }\n\n  #mocha ul,\n  #mocha li {\n    margin: 0;\n    padding: 0;\n  }\n\n  #mocha ul {\n    list-style: none;\n  }\n\n  #mocha h1,\n  #mocha h2 {\n    margin: 0;\n  }\n\n  #mocha h1 {\n    margin-top: 15px;\n    font-size: 1em;\n    font-weight: 200;\n  }\n\n  #mocha h1 a {\n    text-decoration: none;\n    color: inherit;\n  }\n\n  #mocha h1 a:hover {\n    text-decoration: underline;\n  }\n\n  #mocha .suite .suite h1 {\n    margin-top: 0;\n    font-size: .8em;\n  }\n\n  #mocha .hidden {\n    display: none;\n  }\n\n  #mocha h2 {\n    font-size: 12px;\n    font-weight: normal;\n    cursor: pointer;\n  }\n\n  #mocha .suite {\n    margin-left: 15px;\n  }\n\n  #mocha .test {\n    margin-left: 15px;\n    overflow: hidden;\n  }\n\n  #mocha .test.pending:hover h2::after {\n    content: '(pending)';\n    font-family: arial, sans-serif;\n  }\n\n  #mocha .test.pass.medium .duration {\n    background: #c09853;\n  }\n\n  #mocha .test.pass.slow .duration {\n    background: #b94a48;\n  }\n\n  #mocha .test.pass::before {\n    content: '\u2713';\n    font-size: 12px;\n    display: block;\n    float: left;\n    margin-right: 5px;\n    color: #00d6b2;\n  }\n\n  #mocha .test.pass .duration {\n    font-size: 9px;\n    margin-left: 5px;\n    padding: 2px 5px;\n    color: #fff;\n    -webkit-box-shadow: inset 0 1px 1px rgba(0,0,0,.2);\n    -moz-box-shadow: inset 0 1px 1px rgba(0,0,0,.2);\n    box-shadow: inset 0 1px 1px rgba(0,0,0,.2);\n    -webkit-border-radius: 5px;\n    -moz-border-radius: 5px;\n    -ms-border-radius: 5px;\n    -o-border-radius: 5px;\n    border-radius: 5px;\n  }\n\n  #mocha .test.pass.fast .duration {\n    display: none;\n  }\n\n  #mocha .test.pending {\n    color: #0b97c4;\n  }\n\n  #mocha .test.pending::before {\n    content: '\u25E6';\n    color: #0b97c4;\n  }\n\n  #mocha .test.fail {\n    color: #c00;\n  }\n\n  #mocha .test.fail pre {\n    color: black;\n  }\n\n  #mocha .test.fail::before {\n    content: '\u2716';\n    font-size: 12px;\n    display: block;\n    float: left;\n    margin-right: 5px;\n    color: #c00;\n  }\n\n  #mocha .test pre.error {\n    color: #c00;\n    max-height: 300px;\n    overflow: auto;\n  }\n\n  #mocha .test .html-error {\n    overflow: auto;\n    color: black;\n    display: block;\n    float: left;\n    clear: left;\n    font: 12px/1.5 monaco, monospace;\n    margin: 5px;\n    padding: 15px;\n    border: 1px solid #eee;\n    max-width: 85%; /*(1)*/\n    max-width: -webkit-calc(100% - 42px);\n    max-width: -moz-calc(100% - 42px);\n    max-width: calc(100% - 42px); /*(2)*/\n    max-height: 300px;\n    word-wrap: break-word;\n    border-bottom-color: #ddd;\n    -webkit-box-shadow: 0 1px 3px #eee;\n    -moz-box-shadow: 0 1px 3px #eee;\n    box-shadow: 0 1px 3px #eee;\n    -webkit-border-radius: 3px;\n    -moz-border-radius: 3px;\n    border-radius: 3px;\n  }\n\n  #mocha .test .html-error pre.error {\n    border: none;\n    -webkit-border-radius: 0;\n    -moz-border-radius: 0;\n    border-radius: 0;\n    -webkit-box-shadow: 0;\n    -moz-box-shadow: 0;\n    box-shadow: 0;\n    padding: 0;\n    margin: 0;\n    margin-top: 18px;\n    max-height: none;\n  }\n\n  /**\n   * (1): approximate for browsers not supporting calc\n   * (2): 42 = 2*15 + 2*10 + 2*1 (padding + margin + border)\n   *      ^^ seriously\n   */\n  #mocha .test pre {\n    display: block;\n    float: left;\n    clear: left;\n    font: 12px/1.5 monaco, monospace;\n    margin: 5px;\n    padding: 15px;\n    border: 1px solid #eee;\n    max-width: 85%; /*(1)*/\n    max-width: -webkit-calc(100% - 42px);\n    max-width: -moz-calc(100% - 42px);\n    max-width: calc(100% - 42px); /*(2)*/\n    word-wrap: break-word;\n    border-bottom-color: #ddd;\n    -webkit-box-shadow: 0 1px 3px #eee;\n    -moz-box-shadow: 0 1px 3px #eee;\n    box-shadow: 0 1px 3px #eee;\n    -webkit-border-radius: 3px;\n    -moz-border-radius: 3px;\n    border-radius: 3px;\n  }\n\n  #mocha .test h2 {\n    position: relative;\n  }\n\n  #mocha .test a.replay {\n    position: absolute;\n    top: 3px;\n    right: 0;\n    text-decoration: none;\n    vertical-align: middle;\n    display: block;\n    width: 15px;\n    height: 15px;\n    line-height: 15px;\n    text-align: center;\n    background: #eee;\n    font-size: 15px;\n    -webkit-border-radius: 15px;\n    -moz-border-radius: 15px;\n    border-radius: 15px;\n    -webkit-transition:opacity 200ms;\n    -moz-transition:opacity 200ms;\n    -o-transition:opacity 200ms;\n    transition: opacity 200ms;\n    opacity: 0.3;\n    color: #888;\n  }\n\n  #mocha .test:hover a.replay {\n    opacity: 1;\n  }\n\n  #mocha-report.pass .test.fail {\n    display: none;\n  }\n\n  #mocha-report.fail .test.pass {\n    display: none;\n  }\n\n  #mocha-report.pending .test.pass,\n  #mocha-report.pending .test.fail {\n    display: none;\n  }\n  #mocha-report.pending .test.pass.pending {\n    display: block;\n  }\n\n  #mocha-error {\n    color: #c00;\n    font-size: 1.5em;\n    font-weight: 100;\n    letter-spacing: 1px;\n  }\n\n  #mocha-stats {\n    position: fixed;\n    top: 15px;\n    right: 10px;\n    font-size: 12px;\n    margin: 0;\n    color: #888;\n    z-index: 1;\n  }\n\n  #mocha-stats .progress {\n    float: right;\n    padding-top: 0;\n\n    /**\n     * Set safe initial values, so mochas .progress does not inherit these\n     * properties from Bootstrap .progress (which causes .progress height to\n     * equal line height set in Bootstrap).\n     */\n    height: auto;\n    -webkit-box-shadow: none;\n    -moz-box-shadow: none;\n    box-shadow: none;\n    background-color: initial;\n  }\n\n  #mocha-stats em {\n    color: black;\n  }\n\n  #mocha-stats a {\n    text-decoration: none;\n    color: inherit;\n  }\n\n  #mocha-stats a:hover {\n    border-bottom: 1px solid #eee;\n  }\n\n  #mocha-stats li {\n    display: inline-block;\n    margin: 0 5px;\n    list-style: none;\n    padding-top: 11px;\n  }\n\n  #mocha-stats canvas {\n    width: 40px;\n    height: 40px;\n  }\n\n  #mocha code .comment { color: #ddd; }\n  #mocha code .init { color: #2f6fad; }\n  #mocha code .string { color: #5890ad; }\n  #mocha code .keyword { color: #8a6343; }\n  #mocha code .number { color: #2f6fad; }\n\n  @media screen and (max-device-width: 480px) {\n    #mocha {\n      margin: 60px 0px;\n    }\n\n    #mocha #stats {\n      position: absolute;\n    }\n  }\n";
//# sourceMappingURL=styles.d.ts.map